package bjoerks.app;

import android.app.Activity;
import android.os.Bundle;
import android.util.Log;
import android.view.KeyEvent;


public class AppSession2Form extends Activity {
    
    private SessionControler session;
    /** Called when the activity is first created. */
    @Override
    public void onCreate(Bundle savedInstanceState)
    {
        super.onCreate(savedInstanceState);
    	if (savedInstanceState != null && savedInstanceState.containsKey("MyModelSerialized"))
    	{
            Log.v("AppSession2Form_Inflate01", "AppSession2Form: OnCreate - restart med state");
    		session = (SessionControler)savedInstanceState.getSerializable("MyModelSerialized");
    		session.ReStart(this);
    	}
    	else
    	{
            Log.v("AppSession2Form_Inflate01", "AppSession2Form: OnCreate - ny state");
    		session = new SessionControler();
    		session.Start(this);
    	}
    }

    @Override
    public void onSaveInstanceState(Bundle outState) 
    {
        super.onSaveInstanceState(outState);
        outState.putSerializable("MyModelSerialized", session);
        Log.v("AppSession2Form_Inflate01", "AppSession2Form: State saved");
    }
    
    @Override
    public boolean onKeyDown (int keyCode, KeyEvent event)
	{
    	if (keyCode == KeyEvent.KEYCODE_HOME)	// Dette overdrages ikke
    		return true;
//    		return super.onKeyDown(keyCode, event);
		if (session.onKeyDown(keyCode, event)) return true;
		return super.onKeyDown(keyCode, event);
	}

    
}