package bjoerks.app;

import java.io.Serializable;

import android.app.Activity;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.EditText;
import android.widget.LinearLayout;
import android.widget.Toast;

public class MyExtraScreenControler extends LinearLayout implements Serializable {

	private static final long serialVersionUID = 1L;

	private SessionControler session;
	
	private EditText myExtraScreenEditText;
	private Button myExtraScreenButtonGet;
	private Button myExtraScreenButtonSet;
	private Button myExtraScreenButtonReturn;
	
	private boolean first = true;

	public MyExtraScreenControler(SessionControler session, MyExtraScreenControler oldMain) 
	{
		super(session.GetActivity());
		this.session = session;
		initMyViewElements();
		setListener();
		if (oldMain != null)
		{
			// brug old til at initere this
			
		}
	}
	private void initMyViewElements()
	{
        Log.v("AppSession2Form_Inflate01", "extra: initGuiElements() start");
		String infService = Activity.LAYOUT_INFLATER_SERVICE;
		LayoutInflater li = (LayoutInflater)getContext().getSystemService(infService);
		li.inflate(R.layout.myextrascreen, this, true);
        myExtraScreenEditText = (EditText) findViewById(R.id.myExtraScreenEditText);
        myExtraScreenButtonGet = (Button) findViewById(R.id.myExtraScreenButtonGet);
        myExtraScreenButtonSet = (Button) findViewById(R.id.myExtraScreenButtonSet);
        myExtraScreenButtonReturn = (Button) findViewById(R.id.myExtraScreenButtonReturn);
        Log.v("AppSession2Form_Inflate01", "extra: initGuiElements() slut");
	}

	
	public void Show(boolean alwaysInitData)
	{
        Log.v("AppSession2Form_Inflate01", "extra: Show(boolean alwaysInitData) start");
        if (first || alwaysInitData)
        {
        	initViewData();
        	first = false;
        }
        ((Activity)getContext()).setContentView(this);
	}

	private void initViewData() 
	{
        Log.v("AppSession2Form_Inflate01", "extra: Show(boolean alwaysInitData) start");
    	this.myExtraScreenEditText.setText("Startvrdi");
	}	
	
	private void setListener()
	{
        this.myExtraScreenButtonGet.setOnClickListener(new OnClickListener() {
			@Override
			public void onClick(View v) {
				onClick_buttonGet();
			}
		});
        this.myExtraScreenButtonSet.setOnClickListener(new OnClickListener() {
			@Override
			public void onClick(View v) {
				onClick_buttonSet();
			}
		});
        this.myExtraScreenButtonReturn.setOnClickListener(new OnClickListener() {
			@Override
			public void onClick(View v) {
				onClick_buttonReturn();
			}

		});
	}

	private void onClick_buttonGet()
	{
        Log.v("AppSession2Form_Inflate01", "extra: onClick_buttonGet() start");
		this.myExtraScreenEditText.setText(""+session.GetBusinessModel().GetCount());
	}	

	private void onClick_buttonSet()
	{
        Log.v("AppSession2Form_Inflate01", "extra: onClick_buttonSet() start");
		try
		{
			int value = Integer.parseInt(this.myExtraScreenEditText.getText().toString());
			session.GetBusinessModel().SetCount(value);
		}
		catch (Exception e)
		{
			Toast.makeText(session.GetActivity(), "Fejl - ikke int", 50).show();
		}
	}

	private void onClick_buttonReturn() 
	{
        Log.v("AppSession2Form_Inflate01", "extra: onClick_buttonReturn() start");
		session.MyExtraScreenControlerReturn();
	}
}
