package bjoerks.app;


import java.io.Serializable;
import android.app.Activity;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.*;

public class MyMainScreenControler extends LinearLayout implements Serializable {
	
	private static final long serialVersionUID = 1L;

	private SessionControler session;
	
	private Button mainButton1;
	private EditText editText1;
	private Button buttonAfbryd;
	private Button buttonStartMyExtraScreen;
	
	private boolean first = true;

	public MyMainScreenControler(SessionControler session, MyMainScreenControler oldMain) 
	{
		super(session.GetActivity());
		this.session = session;
		initMyViewElements();
		setListener();
		if (oldMain != null)
		{
			// brug old til at initere this, hvis der er lokale data
			
		}
	}
	private void initMyViewElements()
	{
        Log.v("AppSession2Form_Inflate01", "main: initGuiElements() start");
		String infService = Activity.LAYOUT_INFLATER_SERVICE;
		LayoutInflater li = (LayoutInflater)getContext().getSystemService(infService);
		li.inflate(R.layout.mymainscreen, this, true);
        mainButton1 = (Button) findViewById(R.id.mainButton1);
        editText1 = (EditText) findViewById(R.id.mainEditText1);
        buttonStartMyExtraScreen = (Button) findViewById(R.id.buttonStartMyExtraScreen);
        buttonAfbryd = (Button) findViewById(R.id.buttonAfbryd);
        Log.v("AppSession2Form_Inflate01", "main: initGuiElements() slut");
	}

	public void Show(boolean alwaysInitData)
	{
        Log.v("AppSession2Form_Inflate01", "main: Show(boolean alwaysInitData) start");
        if (first || alwaysInitData)
        {
        	initViewData();
        	first = false;
        }
        ((Activity)getContext()).setContentView(this);
	}

	private void initViewData() 
	{
        Log.v("AppSession2Form_Inflate01", "main: initViewData() start");

        this.editText1.setText(""+session.GetBusinessModel().GetCount());
	}
		
	private void setListener()
	{
        this.mainButton1.setOnClickListener(new OnClickListener() {
			@Override
			public void onClick(View v) {
				onClick_button1();
			}
		});
        this.buttonStartMyExtraScreen.setOnClickListener(new OnClickListener() {
			@Override
			public void onClick(View v) {
				onClick_buttonStartMyExtraScreen();
			}
		});
        this.buttonAfbryd.setOnClickListener(new OnClickListener() {
			@Override
			public void onClick(View v) {
				onClick_buttonAfbryd();
			}

		});
	}

	private void onClick_button1()
	{
        Log.v("AppSession2Form_Inflate01", "main: onClick_button1() start");
		session.GetBusinessModel().IncrementCount();
		this.editText1.setText(""+session.GetBusinessModel().GetCount());
	}	

	private void onClick_buttonStartMyExtraScreen()
	{
        Log.v("AppSession2Form_Inflate01", "main: onClick_buttonStartMyExtraScreen() start");
		session.AcrivateMyExtraScreenControler(true);
	}
	private void onClick_buttonAfbryd()
	{
        Log.v("AppSession2Form_Inflate01", "main: onClick_buttonAfbryd() start");
		session.MyMainControlerStop();
	}
}
