package bjoerks.app;

import java.io.Serializable;

import android.app.Activity;
import android.content.Context;
import android.util.Log;
import android.view.KeyEvent;
import android.view.View;

public class SessionControler implements Serializable {

	private static final long serialVersionUID = 3532098501638049304L;
	
	private Activity parrentActivity;
	private BusinessModel model;

	private MyMainScreenControler mainScreenCtrl;
	private MyExtraScreenControler 	myExtraScreenCtrl;
	
	private View currentView;

    public SessionControler() {
    }
    public void Start(Activity parrentActivity)
    {	// kaldes fra Activity
        Log.v("AppSession2Form_Inflate01", "SessionControler: Start(Activity parrentActivity)");
		this.parrentActivity = parrentActivity;
		model = new BusinessModel();
		MainScreenActivate(true);
	}
    public void ReStart(Activity parrentActivity)
    {	// kaldes fra Activity
        Log.v("AppSession2Form_Inflate01", "SessionControler: ReStart(Activity parrentActivity)");
    	this.parrentActivity = parrentActivity;
    	if (currentView != null && currentView == myExtraScreenCtrl)
    		AcrivateMyExtraScreenControler(false);
		else
    		MainScreenActivate(false);
	}
    public Activity GetActivity() {
		return this.parrentActivity;
	}
    public BusinessModel GetBusinessModel()
    {
		return this.model;
	}
    private void MainScreenActivate(boolean alwaysInitData)
    {
    	if (mainScreenCtrl == null || mainScreenCtrl.getContext() != (Context)this.parrentActivity)
    		mainScreenCtrl = new MyMainScreenControler(this,mainScreenCtrl);
    	mainScreenCtrl.Show(alwaysInitData);
    	currentView = mainScreenCtrl;
    }
    public void MyMainControlerStop() {
    	parrentActivity.finish();
    }
    public void AcrivateMyExtraScreenControler(boolean alwaysInitDat) {
    	if (myExtraScreenCtrl == null || myExtraScreenCtrl.getContext() != (Context)this.parrentActivity)
    		myExtraScreenCtrl = new MyExtraScreenControler(this,myExtraScreenCtrl);
    	myExtraScreenCtrl.Show(alwaysInitDat);
    	currentView = myExtraScreenCtrl;
    }
    public void MyExtraScreenControlerReturn() {
		MainScreenActivate(true);
    }
    public boolean onKeyDown (int keyCode, KeyEvent event)
	{
		switch (keyCode)
		{
			case KeyEvent.KEYCODE_BACK:
		    	this.parrentActivity = parrentActivity;
		    	if (currentView != null && currentView == myExtraScreenCtrl)
		    		MainScreenActivate(false);
				else
					parrentActivity.finish();
				break;
			default: 
				return false; // ikke handlet
		}
		return true;	// event handled
	}



}
